@ECHO off
CLS
REM ##########################################################
REM ##########  PATRIOT ASTRO END OF NIGHT SCRIPT  ###########
REM ##########################################################
REM ###########  USE AT YOUR OWN RISK AND REWARD  ############
REM #######  I AM NOT RESPONSIBLE FOR ANY DATA LOSS  #########
REM ##########################################################

REM >>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
REM >>>>> SET INITIAL VARIABLES -- THIS IS CRITICALLY IMPORTANT <<<<
REM >>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
REM >>> REMOTEROOT EXAMPLE :: SET "REMOTEROOT=\\astro-xeon\_TRANSFER\_ROBOCOPy\From_EQ6"
REM >>> KEEPHOWMANYFILES controls the total number of log files (local) AND zipped backups (remote)

SET "REMOTEROOT=NOT_SET"
SET "KEEPHOWMANYFILES=10"

REM CHECK FOR CONFIGURED INITIAL VARIABLES
if /I "%REMOTEROOT%"=="NOT_SET" (
    ECHO You Must Configure the PA_EON.bat File Initial Variables!
	GOTO :EXIT
)

REM Set time/date variables for logging events and file naming
FOR /f "tokens=2 delims==" %%a IN ('wmic OS Get localdatetime /value') DO SET "dt=%%a"
SET "YY=%dt:~2,2%" & SET "YYYY=%dt:~0,4%" & SET "MM=%dt:~4,2%" & SET "DD=%dt:~6,2%"
SET "HH=%dt:~8,2%" & SET "Min=%dt:~10,2%" & SET "Sec=%dt:~12,2%"

REM >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
REM >>>>> CHECK FOR LOGS AND BACKUPS FOLDERS                                                    <<<<
REM >>>>> OTHER FOLDERS WILL BE CREATED AS NEEDED BASED ON YOUR _pa_task_list.txt CONFIGURATION <<<<
REM >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
IF NOT EXIST "%~dp0\logs" MKDIR "%~dp0\logs"
IF NOT EXIST "%REMOTEROOT%\BACKUPS" MKDIR "%REMOTEROOT%\BACKUPS"

REM >>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<
REM >>>>>>> INITIALIZE LOG OUTPUT <<<<<<
REM >>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<
ECHO *******************************************************************************>>%~dp0\logs\PA_EON_%YYYY%%MM%%DD%_%HH%%Min%%Sec%.log
ECHO ******************  PATRIOT ASTRO END OF NIGHT FILE MIGRATION  ****************>>%~dp0\logs\PA_EON_%YYYY%%MM%%DD%_%HH%%Min%%Sec%.log
ECHO ***************************  %YYYY%-%MM%-%DD% %HH%:%Min%:%Sec%  *****************************>>%~dp0\logs\PA_EON_%YYYY%%MM%%DD%_%HH%%Min%%Sec%.log
ECHO *******************************************************************************>>%~dp0\logs\PA_EON_%YYYY%%MM%%DD%_%HH%%Min%%Sec%.log

REM >>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<
REM >>>>>>>> KILL PROCESSES <<<<<<<<
REM >>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<

ECHO ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~>>%~dp0\logs\PA_EON_%YYYY%%MM%%DD%_%HH%%Min%%Sec%.log
REM Kill PHD2 if running to ensure we can access log files for backup
ECHO +++ KILL PHD2 IF RUNNING>>%~dp0\logs\PA_EON_%YYYY%%MM%%DD%_%HH%%Min%%Sec%.log
c:\Windows\system32\taskkill.exe  /F /IM phd2.exe>>%~dp0\logs\PA_EON_%YYYY%%MM%%DD%_%HH%%Min%%Sec%.log
ECHO ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~>>%~dp0\logs\PA_EON_%YYYY%%MM%%DD%_%HH%%Min%%Sec%.log

REM >>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<
REM >>>>>> ROBOCOPY TRANSFERS <<<<<<
REM >>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<
REM You MUST configure the _pa_task_list.txt file to reflect what you hope to accomplish
REM NOTES: There MUST be a blank line after the last entry in _pa_task_list.txt
REM NOTES: There MUST be 5 comma separated entries (fields) per line in each _pa_task_list.txt entry
REM NOTES: Field 1 = NAME of the Task that will be logged
REM NOTES: Field 2 = COMPLETE_LOCAL_FOLDER_PATH of the Task where the files reside
REM NOTES: Field 3 = REMOTE_FOLDER_NAME to use for this Task (will be created if needed inside REMOTEROOT - should be defined above)
REM NOTES: Field 4 = ROBOCOPY_OPTIONAL_MATCHING is REQUIRED to be either a single blank space or a valid matching pattern for RoboCopy (example: *Log*.txt)
REM NOTES: Field 5 = BACKUP_VIA_ZIP_OPTION is either a 1 (files will be zipped and backed up) or a 0 (to not zip and backup)
REM NOTES: Field 5 Explanation: All Files in _pa_task_list.txt are moved as expected BUT some can additionally be zipped and stored as a backup for KEEPHOWMANYFILES times
REM NOTES: Field 5 Explanation: You likely do not want to zip and backup large image transfers from apps like NINA or SHARPCAP to limit disk consuption

SETLOCAL
FOR /f "tokens=1,2,3,4,5 delims=," %%A IN (%~dp0\_pa_task_list.txt) DO (
  ECHO ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~>>%~dp0\logs\PA_EON_%YYYY%%MM%%DD%_%HH%%Min%%Sec%.log
  ECHO +++ %%A>>%~dp0\logs\PA_EON_%YYYY%%MM%%DD%_%HH%%Min%%Sec%.log
  start /wait c:\windows\system32\robocopy.exe "%%B" "%REMOTEROOT%\%%C" %%D /Z /S /FFT /XO /NP /LOG+:%~dp0\logs\PA_EON_%YYYY%%MM%%DD%_%HH%%Min%%Sec%.log
  if /I "%%E" EQU "1" (start /wait powershell -executionpolicy bypass -Command "Compress-Archive -Update -Path %REMOTEROOT%\%%C -DestinationPath %REMOTEROOT%\BACKUP_%YYYY%%MM%%DD%_%HH%%Min%%Sec%.zip")
  ECHO ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~>>%~dp0\logs\PA_EON_%YYYY%%MM%%DD%_%HH%%Min%%Sec%.log
) 
MOVE %REMOTEROOT%\*.zip %REMOTEROOT%\BACKUPS

REM >>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<
REM >>>>>>>>> FILE CLEANUP <<<<<<<<<
REM >>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<
ECHO LIST OF FILES IN %REMOTEROOT%\BACKUPS\ BEFORE CLEANUP>>%~dp0\logs\PA_EON_%YYYY%%MM%%DD%_%HH%%Min%%Sec%.log
DIR %REMOTEROOT%\BACKUPS\*.zip /b /o-d>>%~dp0\logs\PA_EON_%YYYY%%MM%%DD%_%HH%%Min%%Sec%.log
ECHO ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~>>%~dp0\logs\PA_EON_%YYYY%%MM%%DD%_%HH%%Min%%Sec%.log
FOR /F "skip=%KEEPHOWMANYFILES% eol=: delims=" %%m in ('dir %REMOTEROOT%\BACKUPS\*.zip /b /o-d') do del "%REMOTEROOT%\BACKUPS\%%m"
FOR /F "skip=%KEEPHOWMANYFILES% eol=: delims=" %%z in ('dir %~dp0\logs\*.log /b /o-d') do del "%~dp0\logs\%%z"
ECHO LIST OF FILES REMAINING AFTER CLEANUP (KEEPING LAST %KEEPHOWMANYFILES%)>>%~dp0\logs\PA_EON_%YYYY%%MM%%DD%_%HH%%Min%%Sec%.log
DIR %REMOTEROOT%\BACKUPS\*.zip /b /o-d>>%~dp0\logs\PA_EON_%YYYY%%MM%%DD%_%HH%%Min%%Sec%.log

REM >>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<
REM >>>>>>> END FILE OUTPUT <<<<<<<<
REM >>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<
ECHO *******************************************************************************>>%~dp0\logs\PA_EON_%YYYY%%MM%%DD%_%HH%%Min%%Sec%.log
ECHO ***********************************  EOF  *************************************>>%~dp0\logs\PA_EON_%YYYY%%MM%%DD%_%HH%%Min%%Sec%.log
ECHO *******************************************************************************>>%~dp0\logs\PA_EON_%YYYY%%MM%%DD%_%HH%%Min%%Sec%.log
start %~dp0\logs\PA_EON_%YYYY%%MM%%DD%_%HH%%Min%%Sec%.log
@(CALL )
ECHO %errorlevel%

:EXIT